<?php

namespace Drupal\simply_signups\Access;

use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;
use Drupal\node\Entity\Node;
use Drupal\node\NodeInterface;
use Symfony\Component\Routing\Route;

/**
 * Check the access to a node task based on the node type.
 */
class SimplySignupsAccess {

  /**
   * A custom access check.
   *
   * @param \Drupal\node\NodeInterface $node
   *   Run access checks for this node.
   */
  public function accessSettings($node) {
    $account = \Drupal::currentUser();
    $nodeObject = Node::load($node);
    $node = $nodeObject;
    $config = \Drupal::config('simply_signups.config');
    $bundles = $config->get('bundles');
    $bundle = $node->bundle();
    $bundleAccess = (in_array($bundle, $bundles, TRUE)) ? 1 : 0;
    $permission = ($account->hasPermission('edit_simply_signups') == 1) ? 1 : 0;
    $y = 0;
    if (($permission == 1) AND ($bundleAccess == 1)) {
      $y = 1;
    }
    return ($y == 1) ? AccessResult::allowed() : AccessResult::forbidden();
  }

  public function accessSignup($node) {
    $account = \Drupal::currentUser();
    $nodeObject = Node::load($node);
    $node = $nodeObject;
    $config = \Drupal::config('simply_signups.config');
    $bundles = $config->get('bundles');
    $bundle = $node->bundle();
    $bundleAccess = (in_array($bundle, $bundles, TRUE)) ? 1 : 0;
    $permission = ($account->hasPermission('view_simply_signups') == 1) ? 1 : 0;
    $y = 0;
    if (($permission == 1) AND ($bundleAccess == 1)) {
      $y = 1;
    }
    return ($y == 1) ? AccessResult::allowed() : AccessResult::forbidden();
  }
}