<?php

namespace Drupal\simply_signups\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\signup\Utility\SignupUtility;
use Drupal\Component\Datetime\TimeInterface;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;

/**
 * Implements a signup form.
 */
class SimplySignupsTemplatesFieldsAddForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'simply_signups_templates_fields_add_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $path = \Drupal::service('path.current')->getPath();
    $currentPath = ltrim($path, '/');
    $arg = explode('/', $currentPath);
    $tid = $arg[4];
    $db = \Drupal::database();
    $query = $db->select('simply_signups_templates', 'p');
    $query->fields('p');
    $query->condition('id', $tid, '=');
    $count = $query->countQuery()->execute()->fetchField();
    if ($count == 0) {
      throw new NotFoundHttpException();
    }
    $form['#attached']['library'][] = 'simply_signups/styles';
    $form['#attributes'] = [
      'class' => ['simply-signups-templates-fields-add-form', 'simply-signups-form'],
    ];
    $form['tid']= [
      '#type' => 'hidden',
      '#value' => $tid,
    ];
    $form['field_type'] = [
      '#type' => 'select',
      '#title' => t('Field Type'),
      '#options' => [
        'checkboxes' => t('Checkboxes'),
        'checkbox' => t('Checkbox'),
        'email' => t('Email'),
        'hidden' => t('Hidden'),
        'number' => t('Number'),
        'radio' => t('Radio'),
        'radios' => t('Radios'),
        'select' => t('Select'),
        'tel' => t('Telephone'),
        'textarea' => t('Textarea'),
        'textfield' => t('Textfield'),
      ],
      '#description' => t('Select the type of field that you wish to add.'),
    ];
    $form['actions'] = [
      '#type' => 'actions',
    ];
    $form['actions']['submit'] = [
      '#type' => 'submit',
      '#value' => t('Select field type'),
      '#attributes' => [
        'class' => [
          'button--primary',
          'btn-primary',
        ],
      ],
    ];
    $form['actions']['cancel'] = [
      '#type' => 'submit',
      '#value'  => 'Cancel',
      '#attributes' => [
        'title' => $this->t('Return to template fields'),
        'class' => [
          'button--danger',
          'btn-link',
        ],
      ],
      '#submit' => ['::cancel'],
      '#limit_validation_errors' => [['tid']],
    ];
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function cancel(array &$form, FormStateInterface $form_state) {
    $values = $form_state->getValues();
    $tid = $values['tid'];
    $form_state->setRedirect('simply_signups.templates.fields', array('tid' => $tid));
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $values = $form_state->getValues();
    $tid = $values['tid'];
    $form_state->setRedirect('simply_signups.templates.fields.'.$values['field_type'], array('tid' => $tid));
    /*if ($values['field_type'] == 'checkboxes') {
      $form_state->setRedirect('simply_signups.templates.fields.checkboxes', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'checkbox') {
      $form_state->setRedirect('simply_signups.templates.fields.checkbox', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'date') {
      $form_state->setRedirect('simply_signups.templates.fields.date', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'email') {
      $form_state->setRedirect('simply_signups.templates.fields.email', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'hidden') {
      $form_state->setRedirect('simply_signups.templates.fields.email', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'markup') {
      $form_state->setRedirect('simply_signups.templates.fields.markup', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'number') {
      $form_state->setRedirect('simply_signups.templates.fields.number', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'radio') {
      $form_state->setRedirect('simply_signups.templates.fields.radio', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'radios') {
      $form_state->setRedirect('simply_signups.templates.fields.radios', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'select') {
      $form_state->setRedirect('simply_signups.templates.fields.select', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'tel') {
      $form_state->setRedirect('simply_signups.templates.fields.tel', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'textarea') {
      $form_state->setRedirect('simply_signups.templates.fields.textarea', array('tid' => $tid));
    }
    else if ($values['field_type'] == 'textfield') {
      $form_state->setRedirect('simply_signups.templates.fields.textfield', array('tid' => $tid));
    }
    else {
      drupal_set_message(t('You have made an invalid selection. Please try again.'), $type = 'error');
    }*/
  }
}